HTTP::Cookie - Crystal 1.10.0

# class HTTP::Cookie

- HTTP::Cookie
- Reference
- Object

##
Overview

Represents a cookie with all its attributes. Provides convenient access and modification of them.

NOTE To use `Cookie`, you must explicitly import it with `require "http/cookie"`

##
Defined in:

http/cookie.cr

##
Constructors

- .new(name : String, value : String, path : String | Nil = nil, expires : Time | Nil = nil, domain : String | Nil = nil, secure : Bool | Nil = nil, http_only : Bool = false, samesite : SameSite | Nil = nil, extension : String | Nil = nil, max_age : Time::Span | Nil = nil, creation_time : Time = Time.utc)

  Creates a new `Cookie` instance.

##
Instance Method Summary

- #==(other : self)

  Returns `true` if this reference is the same as other.

- #creation_time : Time
- #domain : String | Nil
- #domain=(domain : String | Nil)
- #expiration_time : Time | Nil

  Returns the expiration time of this cookie.

- #expired?(time_reference = Time.utc) : Bool

  Returns the expiration status of this cookie as a `Bool`.

- #expires : Time | Nil
- #expires=(expires : Time | Nil)
- #extension : String | Nil
- #extension=(extension : String | Nil)
- #hash(hasher)

  See `Object#hash(hasher)`

- #http_only : Bool
- #http_only=(http_only : Bool)
- #max_age : Time::Span | Nil
- #max_age=(max_age : Time::Span | Nil)
- #name : String
- #name=(name : String)

  Sets the name of this cookie.

- #path : String | Nil
- #path=(path : String | Nil)
- #samesite : SameSite | Nil
- #samesite=(samesite : SameSite | Nil)
- #secure : Bool

  Returns `true` if this cookie has the Secure flag.

- #secure=(secure : Bool) : Bool
- #to_cookie_header(io) : Nil
- #to_cookie_header : String
- #to_set_cookie_header : String
- #valid? : Bool

  Returns `false` if `#name` has a security prefix but the requirements are not met as per RFC 6265 bis §4.1.3, otherwise returns `true`.

- #validate! : self

  Raises `ArgumentError` if `self` is not `#valid?`.

- #value : String
- #value=(value : String)

  Sets the value of this cookie.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(name : String, value : String, path : String | Nil = nil, expires : Time | Nil = nil, domain : String | Nil = nil, secure : Bool | Nil = nil, http_only : Bool = false, samesite : SameSite | Nil = nil, extension : String | Nil = nil, max_age : Time::Span | Nil = nil, creation_time : Time = Time.utc) #

Creates a new `Cookie` instance.

Raises `IO::Error` if name or value are invalid as per RFC 6265 §4.1.1. Raises `ArgumentError` if name has a security prefix but the requirements are not met as per RFC 6265 bis §4.1.3. Alternatively, if name has a security prefix, and the related properties are `nil`, the prefix will automatically be applied to the cookie.

##
Instance Method Detail

def ==(other : self) #
Description copied from class Reference

Returns `true` if this reference is the same as other. Invokes `same?`.

def creation_time : Time #
def domain : String | Nil #
def domain=(domain : String | Nil) #
def expiration_time : Time | Nil #

Returns the expiration time of this cookie.

def expired?(time_reference = Time.utc) : Bool #

Returns the expiration status of this cookie as a `Bool`.

time_reference can be passed to use a different reference time for comparison. Default is the current time (`Time.utc`).

def expires : Time | Nil #
def expires=(expires : Time | Nil) #
def extension : String | Nil #
def extension=(extension : String | Nil) #
def hash(hasher) #
Description copied from class Reference

See `Object#hash(hasher)`

def http_only : Bool #
def http_only=(http_only : Bool) #
def max_age : Time::Span | Nil #
def max_age=(max_age : Time::Span | Nil) #
def name : String #
def name=(name : String) #

Sets the name of this cookie.

Raises `IO::Error` if the value is invalid as per RFC 6265 §4.1.1.

def path : String | Nil #
def path=(path : String | Nil) #
def samesite : SameSite | Nil #
def samesite=(samesite : SameSite | Nil) #
def secure : Bool #

Returns `true` if this cookie has the Secure flag.

def secure=(secure : Bool) : Bool #
def to_cookie_header(io) : Nil #
def to_cookie_header : String #
def to_set_cookie_header : String #
def valid? : Bool #

Returns `false` if `#name` has a security prefix but the requirements are not met as per RFC 6265 bis §4.1.3, otherwise returns `true`.

def validate! : self #

Raises `ArgumentError` if `self` is not `#valid?`.

def value : String #
def value=(value : String) #

Sets the value of this cookie.

Raises `IO::Error` if the value is invalid as per RFC 6265 §4.1.1.